function [states,q,qa,transitions,I,U,configuration] = getBouncingBallInput_Inv
% Bouncing Ball
        
        % definition of locations -----------------------------------------
        % continuous dynamics in each state        
        states{1}.A = [0,1;0,0];        
        states{1}.b = [0;-9.81];   
        states{1}.B = [1 0;0 1];
        states{1}.C = [-1 0];
        states{1}.d = [0];
        
        q=[1]; % discrete states 
        qa=1; % initial mode
        
        % definition of transitions ---------------------------------------
		
        % guards d.x=e for each transition 
        transitions{1}.eguards_dir = [1 0];
        transitions{1}.eguards_val = [0];
        
        % Inequalities guards d.x<=e for each transition 
        transitions{1}.iguards_dir = [0 1];
        transitions{1}.iguards_val = [0];
        
        % Reset
        transitions{1}.ResetMatrix = [1,0; 0,-0.6];
        transitions{1}.W = [0;0]; 
        
        % start and end location of the transition nbr 1
        transitions{1}.from = 1;
        transitions{1}.to = 1;
        
        % initial values --------------------------------------------------
        
        % initial set (as polyheder)
        I.polyheder.C = vectorgenerator(2) ;
        I.polyheder.d = [2;-2;0;0];
        
        % input set (as zonotope)
        U.zonotope.c=[0;0];
        U.zonotope.g=0.001*eye(2,2);

        % input set (as box)
        U.box = [0;0];
        
        % configuration parameters ----------------------------------------
        configuration.timehorizon = 0.8; % time horizon
        configuration.timestep = 0.01; % timestep
        
        