function [states,q,qa,transitions,I,U,configuration] = getNavigation5Input
 % Navigation 5
     
        % definition of locations -----------------------------------------
        % continuous dynamics in each state        
        states{1}.A = [0,0,1,0;...
                       0,0,0,1;...
                       0,0,-1.2,0.1;...
                       0,0,0.1,-1.2];        
        states{1}.b = [0;0;0.1;-1.2];   
        states{1}.B = [1; 0; 0; 0];
        
        states{2}.A = [0,0,1,0;...
                       0,0,0,1;...
                       0,0,-1.2,0.1;...
                       0,0,0.1,-1.2];        
        states{2}.b = [0;0;1.2;-0.1];   
        states{2}.B = [1; 0; 0; 0];
        
        q=[1,2]; % discrete states
        qa=1; % initial mode
        
        % definition of transitions --------------------------------------- 
        % guards d.x=e for each transition 
        transitions{1}.eguards_dir = [0 1 0 0];
        transitions{1}.eguards_val = [1];

        % start and end location of the transition nbr 1
        transitions{1}.from = 1;
        transitions{1}.to = 2;

   
        % initial values --------------------------------------------------
        % initial set (as polyheder)
        I.polyheder.C = vectorgenerator(4); 
        I.polyheder.d = [0.4;-0.4;2.8;-2.8;0.3;-0.3;-0.3;0.3];
                      
        % input set (as box)
        U.box = 0;

        % configuration parameters ----------------------------------------
        configuration.timehorizon = 5; % time horizon
        configuration.timestep = 0.01; % timestep
 