function [states,q,qa,transitions,I,U,configuration] = getTwoTankInput  % getsysprmtrs: Get System Parameters
% 2 Tank system

        % definition of locations -----------------------------------------
        % continuous dynamics in each state        
        states{1}.A = [-1,0;1,0];        
        states{1}.b = [-2;0];   
        states{1}.B = [1 ; 1];
        
        states{2}.A = [-1,0;1,0];  
        states{2}.b = [3;0];  
        states{2}.B = [1 ; 1];
        
        states{3}.A = [-1,0;1,-1];  
        states{3}.b = [-2;-5];  
        states{3}.B = [1 ; 1];
        
        states{4}.A = [-1,0;1,-1];  
        states{4}.b = [3;-5];  
        states{4}.B = [1 ; 1];
        
        q=[1,2,3,4];  % discrete states 
        qa=3; % initial mode
        
        % definition of transitions ---------------------------------------
        % guards d.x=e for each transition
        transitions{1}.eguards_dir = [1 0];
        transitions{1}.eguards_val = [-1];
        
        transitions{2}.eguards_dir = [0 1];
        transitions{2}.eguards_val = [1];
        
        transitions{3}.eguards_dir = [0 1];
        transitions{3}.eguards_val = [1];
        
        transitions{4}.eguards_dir = [0 1];
        transitions{4}.eguards_val = [0];
        
        transitions{5}.eguards_dir = [1 0];
        transitions{5}.eguards_val = [-1];
        
        transitions{6}.eguards_dir = [0 1];
        transitions{6}.eguards_val = [0];
        
        transitions{7}.eguards_dir = [1 0];
        transitions{7}.eguards_val = [1];

        % start and end location of the transition nbr 1
        transitions{1}.from = 1;
        transitions{1}.to = 2;
        
        % start and end location of the transition nbr 2
        transitions{2}.from = 1;
        transitions{2}.to = 3;
        
        % start and end location of the transition nbr 3
        transitions{3}.from = 2;
        transitions{3}.to = 3;
        
        % start and end location of the transition nbr 4
        transitions{4}.from = 3;
        transitions{4}.to = 1;
        
        % start and end location of the transition nbr 5
        transitions{5}.from = 3;
        transitions{5}.to = 4;
        
        % start and end location of the transition nbr 6
        transitions{6}.from = 4;
        transitions{6}.to = 2;
        
        % start and end location of the transition nbr 7
        transitions{7}.from = 4;
        transitions{7}.to = 3;
        
        % initial values --------------------------------------------------
        % initial set (as polyheder)
        I.polyheder.C = vectorgenerator(2) ;
        I.polyheder.d = [2.5;-1.5;1;-1];
        
        % input set (as box)
        U.box = 0.1;

        % configuration parameters ----------------------------------------
        configuration.timehorizon = 1; % time horizon
        configuration.timestep = 0.01; % timestep
     