function [states,q,qa,transitions,I,U,configuration] = getrssCase8Input
% Rss-case-8

         % definition of locations -----------------------------------------
         % continuous dynamics in each state    
         states{1}.A =[   -0.8047    8.7420   -2.4591   -8.2714   -1.8640;...
                          -8.6329   -0.5860   -2.1006    3.6035   -1.8423;...
                           2.4511    2.2394   -0.7538   -3.6934    2.4585;...
                           8.3858   -3.1739    3.7822   -0.6249    1.8829;...
                           1.8302    1.9869   -2.4539   -1.7726   -0.79111];
         states{1}.B = [-0.0845;0;0;0;-0.7342];
        
         states{2}.A = [-0.8316    8.7658   -2.4744   -8.2608   -1.9033;...
                        -8.6329   -0.5860   -2.1006    3.6035   -1.8423;...
                        2.4511    2.2394   -0.7538   -3.6934    2.4585;...
                        8.3858   -3.1739    3.7822   -0.6249    1.8829;...
                        1.5964    2.1936   -2.5872   -1.6812   -1.1324];
         states{2}.B = [-0.0845;0;0;0;-0.7342];
     
         states{3}.A = [-0.9275    8.8628   -2.5428   -8.2329   -2.0324;...
                        -8.6329   -0.5860   -2.1006    3.6035   -1.8423 ;...
                        2.4511    2.2394   -0.7538   -3.6934    2.4585;...
                        8.3858   -3.1739    3.7822   -0.6249    1.8829;...
                        0.7635    3.0357   -3.1814   -1.4388   -2.2538];
         states{3}.B = [-0.0845;0;0;0;-0.7342];
                        
         states{4}.A = [-1.0145    8.9701   -2.6207   -8.2199   -2.1469;...
                        -8.6329   -0.5860   -2.1006    3.6035   -1.8423;...
                         2.4511    2.2394   -0.7538   -3.6934    2.4585;...
                         8.3858   -3.1739    3.7822   -0.6249    1.8829;...
                         0.0076    3.9682   -3.8578   -1.3253   -3.2477];
         states{4}.B = [-0.0845;0;0;0;-0.7342];
                        
         states{5}.A = [-1.4021   10.1647   -3.3937   -8.5139   -2.9602;...
                        -8.6329   -0.5860   -2.1006    3.6035   -1.8423;...
                        2.4511    2.2394   -0.7538   -3.6934    2.4585;...
                        8.3858   -3.1739    3.7822   -0.6249    1.8829;...
                        -3.3585   14.3426  -10.5703   -3.8785  -10.3111];
         states{5}.B = [-0.0845;0;0;0;-0.7342];
          
         q=[1,2,3,4,5]; % discrete states                  
         qa = 1;

         % definition of transitions ---------------------------------------
         % guards d.x=e for each transition 
         transitions{1}.eguards_dir = [1 0 0 0 0];
         transitions{1}.eguards_val = [3];
         
         transitions{2}.eguards_dir = [1 0 0 0 0];
         transitions{2}.eguards_val = [2];
         
         transitions{3}.eguards_dir = [1 0 0 0 0];
         transitions{3}.eguards_val = [1];
         
         transitions{4}.eguards_dir = [1 0 0 0 0];
         transitions{4}.eguards_val = [0];
         
         transitions{5}.eguards_dir = [1 0 0 0 0];
         transitions{5}.eguards_val = [1];
         
        % transitions row1=source, row2=target
         qq=[1,2,3,4,5;...
             2,3,4,5,1];

         % start and end location of the transition nbr 1
         transitions{1}.from = 1;
         transitions{1}.to = 2;
         
         % start and end location of the transition nbr 2
         transitions{2}.from = 2;
         transitions{2}.to = 3;
         
         % start and end location of the transition nbr 3
         transitions{3}.from = 3;
         transitions{3}.to = 4;
         
         % start and end location of the transition nbr 4
         transitions{4}.from = 4;
         transitions{4}.to = 5;
         
         % start and end location of the transition nbr 5
         transitions{5}.from = 5;
         transitions{5}.to = 1;
        
         % initial values -------------------------------------------------
         % initial set (as polyheder)
         I.polyheder.C = vectorgenerator(5);
         I.polyheder.d = [3;-3;4;-4;0;0;0;0;0;0];
         
         % input set (as zonotope)
         U.c=[0];
         U.g=[1];
         
         % input set (as box)
         U.box = 1;

         % configuration parameters ----------------------------------------
         configuration.timehorizon = 1; % time horizon
         configuration.timestep = 0.01; % timestep      
