% Input:
% px0: function handle (support function of initial set)
% Sigmatau: matrix
% pv: support function
% alpha: double
% pb: function handle (support function of unit ball)
% tau: double

% Output:
% x: function handle (support function overapproximating the initial set)

% Description:
% Generates Omega0, initial set for reachability analysis,
% representated by a support function (for algo1)

function [x] = calcPinit(px0,Sigmatau,pv,alpha,pb,tau)
x = @(l) max([px0(l) , px0(Sigmatau'*l)+tau*pv(l)+alpha*pb(l)]);