% Input:
% t: double (sampling time)
% pv: function handle (support function of hte input BU)
% b: double (beta_tau for algo1)
% pb: function handle (support function of a unit ball)

% Ouput:
% x: function handle (support function)

% Decription:
% Computes the support function of an overapproximation for set BU (for
% algo1)

function [x] = calcPw(t,pv,b,pb)
x = @(l) t*pv(l) + b*pb(l);