% Input:
% delta: Double (sampling time)
% u: function handle (support function of free input)
% epsilonpsi: function handle (support function)

% Output:
% psidelta: function handle (Support function)

% Description:
% Generates psidelta of set U (for algoSpaceEx)

function [psidelta] = calcpsidelta(delta,u,epsilonpsi)
psidelta = @(l) delta*u(l) + epsilonpsi(l);
