% Input:
% leftbound: double (lower bound on the interval)
% rightbound: double (upper bound on the interval)
% input: string

% Output:
% x: bool (true if transformation has been done successfull)
% v: integer (value contained in the input string)

% Description:
% Checks if a integer value given via input as string is in the interval
% [leftbound,rightbound] and transforms the input string in this case to a
% integer value.

% Beschreibung:
% prft ob input ein Integer im Intervall [leftbound,rightbound] ist. Falls
% ja ist x true und v enthlt den konvertierten Wert.

function [x,v] = checkIntegerInput(leftbound,rightbound,input)
v = str2double(input);

if isnan(v) || isempty(v)
    x = false;
else
    
    v = int32(v);
    
    if leftbound <= v && v <= rightbound
        x = true;
    else
        x = false;
    end;
end;